"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propTypes = exports.allowedProps = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _FormPropTypes = require("@instructure/ui-form-field/lib/FormPropTypes.js");
var _controllable = require("@instructure/ui-prop-types/lib/controllable.js");
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

const propTypes = exports.propTypes = {
  renderLabel: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  type: _propTypes.default.oneOf(['text', 'email', 'url', 'tel', 'search', 'password']),
  id: _propTypes.default.string,
  value: (0, _controllable.controllable)(_propTypes.default.string),
  defaultValue: _propTypes.default.string,
  interaction: _propTypes.default.oneOf(['enabled', 'disabled', 'readonly']),
  messages: _propTypes.default.arrayOf(_FormPropTypes.FormPropTypes.message),
  size: _propTypes.default.oneOf(['small', 'medium', 'large']),
  textAlign: _propTypes.default.oneOf(['start', 'center']),
  width: _propTypes.default.string,
  htmlSize: _propTypes.default.number,
  display: _propTypes.default.oneOf(['inline-block', 'block']),
  shouldNotWrap: _propTypes.default.bool,
  placeholder: _propTypes.default.string,
  isRequired: _propTypes.default.bool,
  elementRef: _propTypes.default.func,
  inputRef: _propTypes.default.func,
  inputContainerRef: _propTypes.default.func,
  renderBeforeInput: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  renderAfterInput: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  onChange: _propTypes.default.func,
  onBlur: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  margin: _propTypes.default.string
};
const allowedProps = exports.allowedProps = ['renderLabel', 'type', 'id', 'value', 'defaultValue', 'interaction', 'messages', 'size', 'textAlign', 'width', 'htmlSize', 'display', 'shouldNotWrap', 'placeholder', 'isRequired', 'elementRef', 'inputRef', 'inputContainerRef', 'renderBeforeInput', 'renderAfterInput', 'onChange', 'onBlur', 'onFocus', 'margin'];