import type { TextInputTheme } from '@instructure/shared-types';
import type { TextInputProps, TextInputStyleProps, TextInputStyle } from './props';
/**
 * ---
 * private: true
 * ---
 * Generates the style object from the theme and provided additional information
 * @param  {Object} componentTheme The theme variable object.
 * @param  {Object} props the props of the component, the style is applied to
 * @param  {Object} state the state of the component, the style is applied to
 * @return {Object} The final style object, which will be used in the component
 */
declare const generateStyle: (componentTheme: TextInputTheme, props: TextInputProps, state: TextInputStyleProps) => TextInputStyle;
export default generateStyle;
//# sourceMappingURL=styles.d.ts.map